#include "BitmapImage.h"
#include "Hooks.h"
#include "W2App.h"

DWORD addrLoadImgFromFile;
BitmapImage* BitmapImage::callLoadImgFromFile(DWORD DD_Display, DWORD Palette, const char * path) {
	if(!DD_Display)
		DD_Display = W2App::getAddrDdDisplay();
	if(!Palette)
		Palette = *(DWORD*)(W2App::getAddrDdDisplay() + 0x3120); // img palette
	BitmapImage* retv;
	_asm mov esi, DD_Display
	_asm push path
	_asm push Palette
	_asm call addrLoadImgFromFile
	_asm mov retv, eax
	return retv;
}

DWORD addrDrawBitmapOnBitmap;
void BitmapImage::callDrawBitmapOnBitmap(BitmapImage *Dst, int posX, int posY, int width, int height, BitmapImage *Src, int srcOffsetX, int srcOffsetY, int a9, int flags) {
	_asm push flags
	_asm push a9
	_asm push srcOffsetY
	_asm push srcOffsetX
	_asm push Src
	_asm push height
	_asm push width
	_asm push posY
	_asm push posX
	_asm mov esi, Dst
	_asm call addrDrawBitmapOnBitmap
}


void BitmapImage::install() {
	auto & hooks = Hooks::getInstance();
	addrLoadImgFromFile = hooks.findSignature("LoadImgFromFile", "\x6A\xFF\x68\x00\x00\x00\x00\x64\xA1\x00\x00\x00\x00\x50\x64\x89\x25\x00\x00\x00\x00\x83\xEC\x0C\x8B\x44\x24\x20\x56\x68\x00\x00\x00\x00\x50\xC7\x44\x24\x00\x00\x00\x00\x00", "???????xx????xxxx????xxxxxxxxx????xxxx?????"); //0x57A2A0;
	addrDrawBitmapOnBitmap = hooks.findSignature("DrawBitmapOnBitmap", "\x55\x8B\xEC\x83\xE4\xF8\x8B\x4D\x10\x8B\x45\x18\x83\xEC\x38\x85\xC9\x53\x57\x0F\x84\x00\x00\x00\x00\x83\x7D\x14\x00\x0F\x84\x00\x00\x00\x00\x8B\x50\x08\x8B\x78\x10\x8B\x46\x20\x8B\x5E\x1C", "??????xxxxxxxxxxxxxxx????xxxxxx????xxxxxxxxxxxx");//, 0x4F6590);
}
