#ifndef WKFLAMINGHEALTHBARS_CONFIG_H
#define WKFLAMINGHEALTHBARS_CONFIG_H

#include <string>
#include <map>
#include <memory>
#include "TeamBar.h"
#include <array>

class BitmapImage;
class Config {
public:
	static inline const std::string iniFile = ".\\wkFlamingHealthBars.ini";
	static inline const std::string defaultSuffix = "-DEFAULT-TEAM-SUFFIX";
	static inline const std::array<std::string, 6> alliances = {"red", "blue", "green", "yellow", "magenta", "cyan"};

	struct TeamBarSettings {
		enum AnimationType {Unknown=0, Flame, Custom};
		std::string filename;

		AnimationType animationType;
		int animationDelay;
		int animationFrames;
		int currentFrame;
		int counter;

		BitmapImage * bitmapImage;
		TeamBarSettings(std::string filename, int animationDelay) : filename(std::move(filename)), animationType(Unknown), animationDelay(animationDelay), animationFrames(0), currentFrame(0), counter(0), bitmapImage(nullptr) {};
	};

private:
	static inline bool moduleEnabled = true;
	static inline bool devConsoleEnabled = true;

	static inline std::map<std::string, std::shared_ptr<TeamBarSettings>> teamSettingsByName;
	static inline std::map<int, std::shared_ptr<TeamBarSettings>> teamSettingsById;
public:
	static void readConfig();
	static bool isModuleEnabled();
	static bool isDevConsoleEnabled();

	static std::map<std::string, std::shared_ptr<TeamBarSettings>> &getTeamSettingsByName();
	static std::map<int, std::shared_ptr<TeamBarSettings>> &getTeamSettingsById();
};


#endif //WKFLAMINGHEALTHBARS_CONFIG_H
