#include <MinHook.h>
#include "Hooks.h"

Hooks::Hooks() {
	SigScanner.GetProcess();
	mod = SigScanner.GetModule();
	if(!mod.dwBase)
		throw std::runtime_error("Failed to initialize signature scanner");
	if (MH_Initialize() != MH_OK)
		throw std::runtime_error("Failed to initialize Minhook");
}

Hooks &Hooks::getInstance() {
	static Hooks instance;
	return instance;
}

void Hooks::hook(std::string name, DWORD pTarget, DWORD *pDetour, DWORD *ppOriginal) {
	if(!pTarget)
		throw std::runtime_error("Hook adress is null: " + name);
	if(MH_CreateHook((LPVOID)pTarget, (LPVOID)pDetour, (LPVOID*)ppOriginal) != MH_OK)
		throw std::runtime_error("Failed to create hook: " + name);
	if(MH_EnableHook((LPVOID)pTarget) != MH_OK)
		throw std::runtime_error("Failed to enable hook: " + name);
	printf("hook: %s 0x%08X -> 0x%08X\n", name.c_str(), pTarget, pDetour);
}

DWORD Hooks::findSignature(std::string name, const char *sig, const char *mask) {
	DWORD ret = SigScanner.FindSignature(mod.dwBase, mod.dwSize, sig, mask);
	if(!ret)
		throw std::runtime_error("Failed to find signature: " + name);
	printf("findSignature: %s = 0x%08X\n", name.c_str(), ret);
	return ret;
}
