#include "TeamBar.h"
#include "Hooks.h"
#include "Config.h"
#include "W2App.h"
#include "BitmapImage.h"

DWORD (__fastcall *origDrawTeamBar)(TeamBar::TeamBarStruct * This, int EDX, int a2, int a3, int a4, int a5);
DWORD __fastcall TeamBar::hookDrawTeamBar(TeamBar::TeamBarStruct * This, int EDX, int a2, int a3, int a4, int a5) {
	auto addrFlag = (DWORD*)(0xBB8 * This->team_number_dword4 + *(DWORD*)(This->gameglobal_dwordC + 0x24) + 0x308);
//	auto teamName = (char*)((This->gameglobal_dwordC + 0x4114) + 0x51C * This->team_number_dword4);
	auto barImages = Config::getTeamSettingsById();

	auto it = barImages.find(This->team_number_dword4);
	if(it != barImages.end()) {
		if(it->second->animationType == Config::TeamBarSettings::Flame) {
			*addrFlag = 1;
			*(BitmapImage**)(This->gameglobal_dwordC +0x53C) = it->second->bitmapImage;
		}
	}
	auto ret = origDrawTeamBar(This, EDX, a2, a3, a4, a5);

	if(it != barImages.end()) {
		if(it->second->animationType == Config::TeamBarSettings::Flame) {
			*addrFlag = 0;
			*(BitmapImage **) (This->gameglobal_dwordC + 0x53C) = 0;
		} else if(it->second->animationType == Config::TeamBarSettings::Custom) {
			auto settings = it->second;
			BitmapImage::callDrawBitmapOnBitmap(This->energy_bar_bitmap_dword14, -3, 2, min(settings->bitmapImage->max_width_dword14, This->energy_bar_bitmap_dword14->current_width_dword24 - 2), barHeight, settings->bitmapImage, 0, settings->currentFrame * barHeight, 0, 0);
		}
	}

	return ret;
}

void TeamBar::onUpdateNonCritical() {
	for(auto & it : Config::getTeamSettingsById()) {
		auto settings = it.second;
		if(settings->animationType == Config::TeamBarSettings::Custom) {
			settings->counter++;
			if(settings->counter > settings->animationDelay) {
				settings->counter = 0;
				settings->currentFrame++;
				if(settings->currentFrame >= settings->animationFrames)
					settings->currentFrame = 0;
			}
		}
	}
}

void TeamBar::install() {
	auto & hooks = Hooks::getInstance();
	DWORD addrDrawTeamBar = hooks.findSignature("DrawTeamBar", "\x83\xEC\x14\x53\x55\x56\x57\x8B\xF9\x8B\x47\x20\x8B\x77\x04\x8B\x4F\x0C\x99\x2B\xC2\xD1\xF8\xC1\xE0\x10\x01\x44\x24\x2C\x8B\xC6\x69\xC0\x00\x00\x00\x00", "??????xxxxxxxxxxxxxxxxxxxxxxxxxxxx????"); //563190
	hooks.hook("DrawTeamBar", addrDrawTeamBar, (DWORD*)&hookDrawTeamBar, (DWORD*)&origDrawTeamBar);
}
