#include <Windows.h>
#include <sigscanner.h>
#include <string>

#include "Config.h"
#include "W2App.h"
#include "BitmapImage.h"
#include "TeamBar.h"
#include "CTaskTurnGame.h"
#include "DevConsole.h"

void install() {
	W2App::install();
	BitmapImage::install();
	TeamBar::install();
	CTaskTurnGame::install();
}

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved) {
	switch(ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			try {
				Config::readConfig();
				if(Config::isModuleEnabled()) {
					if(Config::isDevConsoleEnabled()) DevConsole::install();
					install();
				}
			} catch(std::exception & e) {
				MessageBoxA(0, e.what(), "wkFlamingHealthBars", MB_ICONERROR);
			}
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
		default:
			break;
	}
	return TRUE;
}
